<template>
  <v-container style="width:60%">
    <p
      style="text-align:center; font-size: 1.5em;"
      v-if="noUserLoggedIn"
    >Log in om je bestellingen te kunnen zien.</p>
    <p
      style="text-align:center; font-size: 1.5em;"
      v-if="noOrdersForUser"
    >Je hebt nog geen bestellingen, bestel een paar producten om hier je aankoopgeschiedenis in te zien.</p>

    <div v-if="!noUserLoggedIn && !noOrdersForUser">
      <h1>Jouw bestellingen</h1>
      <hr>
      <br>
      <v-card style="margin-bottom: 1.5em;" v-for="order of orders" :key="order._id">
        <v-card-actions>
          {{format(order.date)}}
          <v-spacer/>
          <span style="font-size:1.3em">{{order.orderLines.length}} producten</span>
          <v-spacer></v-spacer>
          <v-btn @click="download(order)" flat color="primary">Download</v-btn>
        </v-card-actions>
      </v-card>
    </div>
  </v-container>
</template>

<script>
import * as moment from "moment";

export default {
  async mounted() {
    try {
      this.orders = await this.$orderService.getOrdersForCurrentUser();
    } catch (e) {
      if (e == "No user logged in.") {
        this.noUserLoggedIn = true;
      }

      if (e == "No orders for user.") {
        this.noOrdersForUser = true;
      }
    }
  },

  data() {
    return {
      noUserLoggedIn: false,
      noOrdersForUser: false,
      orders: []
    };
  },

  methods: {
    download(order) {
      const user = this.$store.state.user.name;
      const orderLines = order.orderLines;

      this.$fileService.download(user, orderLines);
    },

    format(date) {
      return moment(date).format("DD-MM-YYYY HH:mm")
    }
  },
};
</script>
